//          CHTML v0.91
// Compile line: gcc -O3 -s -o chtml.exe chtml.c
// Last update:  May 12,1998
// Author:       Cloud Wu
// E-mail:       cloudwu@nease.net
// URL:          http://www.nease.net/~cloudwu

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void copywrite()
{
 puts("\tCHTML v0.91  August 2,1998");
 puts("\t\tWritten by Cloud Wu");
 puts("It can convert the HTML written by software which dosn't support Chinese.");
 puts("http://www.nease.net/~cloudwu  E-mail: cloudwu@263.net");
}

int main(int agc, char *agv[])
{
 char *addmsg="<!CONVERT BY CHTML v0.91>\r\n";
 FILE *f;
 long size,i,j,s;
 char *buf;
 char word[8];
 char *code="\xa1&iexcl\xa2&cent\xa3&pound\xa4&curren\xa5&yen\xa6\
&brvbar\xa7&sect\xa8&uml\xa9&copy\xaa&ordf\xab&laquo\xac&not\xad\
&shy\xae&reg\xaf&macr\xb0&deg\xb1&plusmn\xb2&sup2\xb3&sup3\xb4&acute\xb5\
&micro\xb6&para\xb7&middot\xb8&cedil\xb9&sup1\xba&ordm\xbb&raquo\xbc\
&frac14\xbd&frac12\xbe&frac34\xbf&iquest\xc0&Agrave\xc1&Aacute\xc2\
&Acirc\xc3&Atilde\xc4&Auml\xc5&Aring\xc6&AElig\xc7&Ccedil\xc8&Egrave\xc9\
&Eacute\xca&Ecirc\xcb&Euml\xcc&Igrave\xcd&Iacute\xce&Icirc\xcf&Iuml\xd0\
&ETH\xd1&Ntilde\xd2&Ograve\xd3&Oacute\xd4&Ocirc\xd5&Otilde\xd6&Ouml\xd7\
&times\xd8&Oslash\xd9&Ugrave\xda&Uacute\xdb&Ucirc\xdc&Uuml\xdd&Yacute\xde\
&THORN\xdf&szlig\xe0&agrave\xe1&aacute\xe2&acirc\xe3&atilde\xe4&auml\xe5\
&aring\xe6&aelig\xe7&ccedil\xe8&egrave\xe9&eacute\xea&ecirc\xeb&euml\xec\
&igrave\xed&iacute\xee&icirc\xef&iuml\xf0&eth\xf1&ntilde\xf2&ograve\xf3\
&oacute\xf4&ocirc\xf5&otilde\xf6&ouml\xf7&divide\xf8&oslash\xf9&ugrave\xfa\
&uacute\xfb&ucirc\xfc&uuml\xfd&yacute\xfe&thorn";
 if (agc<2) {
    copywrite();
    puts("\nUsage:\tCHTML file1.htm file2.htm ...");
    puts("\n\tHTML *.htm");
    return 1;
    }
 for (s=1;s<agc;s++) {
    if ((f=fopen(agv[s],"rb"))==NULL) {
        printf("Error: Can't open %s\n",agv[1]);
        return 2;
        }
    fseek(f,0L,SEEK_END);
    size=ftell(f)+1;
    fseek(f,0L,SEEK_SET);
    if ((buf=(char*)malloc(size))==NULL) {
        puts("Error: Not enough memory");
        return 3;
        }
    fread(buf,size,1,f);
    fclose(f);
    buf[size]=0;
    for(i=0;buf[i];++i) {
        if (buf[i]!='&') continue;
        for (j=0;j<8 && buf[i+j] && buf[i+j]!=';' && buf[i+j+1]!='&';++j) ;
        if (buf[i+j]==';') {
           char *temp;
           for (j=0;buf[i+j]!=';';++j) word[j]=buf[i+j];
           word[j]=0;
           if (temp=strstr(code,word)) buf[i]=*(temp-1);
           else {
                i+=j;
                continue;
                }
           size-=j;
           memmove(buf+i+1,buf+i+j+1,size-i);
           }
        }
     if ((f=fopen(agv[s],"wb"))==NULL) {
        printf("Error: Can't write to %s\n",agv[1]);
        return 3;
        }
     if (strncmp(buf,addmsg,strlen(addmsg)))
        fputs(addmsg,f);
     fwrite(buf,size-1,1,f);
     fclose(f);
     free(buf);
    }
     puts("Convert complete! :-)");
}



